/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include <oo.h>
#include "OO7.h"
#include "GenParams.h"
#include "BenchParams.h"

//////////////////////////////////////////////////////////////////
//
// Delete - Delete NumNewCompParts randomly chosen composite parts. 
//
//////////////////////////////////////////////////////////////////


extern ooTrans	xact;
extern int	debugMode;
extern int	nextCompositeId;


//////////////////////////////////////////////////////////////////
//
// Routine to do Delete
//
//////////////////////////////////////////////////////////////////


void delete1(ooHandle(ooDBObj)& databaseH)
{

    // get access to the design library holding composite parts

    ooHandle(ooContObj) designLibH;
    designLibH.open(databaseH, "DesignLibrary", oocRead);
    if (designLibH.isValid() == oocFalse) {
        fprintf(stderr, "ERROR: Unable to access DesignLibrary\n");
	xact.abort();
        exit(1);
    }

    // now delete the desired number of new composite parts

    int id;
    ooKey key;
    key.type = oocInt32;
    key.offset = ooGetMemberOffset(CompositePart, id);
    key.size   = ooGetMemberSize(CompositePart, id);
    key.value  = &id;
    ooHandle(CompositePart) compH;


    for (int i = 0; i < NumNewCompParts; i++) {
        id = nextCompositeId++;
        if (debugMode) {
	    printf("In Delete, looking up composite part %d\n", id);
	}
        compH.lookupObj(designLibH, key);
        if (compH.isValid() == oocFalse) {
            fprintf(stderr, "ERROR: Unable to locate composite part %d\n", id);
        } else {
	    ooDelete(compH);
	}
    }
}

