/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include <oo.h>
#include "OO7.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #7 --- iterate through all atomic parts.  Checks scan
// speed.  Some duplication with other queries, especially in
// systems that lack indices and force the other queries to be
// done by iterating through sets.
//
//////////////////////////////////////////////////////////////////


extern ooTrans	xact;
extern int	debugMode;


//////////////////////////////////////////////////////////////////
//
// Routine to do Query #7
//
//////////////////////////////////////////////////////////////////


int query7(ooHandle(ooDBObj)& databaseH)
{

    // get access to the design library containing atomic parts

    ooHandle(ooContObj) designLibH;
    designLibH.open(databaseH, "DesignLibrary", oocRead);
    if (designLibH.isValid() == oocFalse) {
        fprintf(stderr, "ERROR: Unable to access DesignLibrary\n");
	xact.abort();
        exit(1);
    }


    int count = 0;
    ooItr(AtomicPart) atomicPartI;
    

    atomicPartI.scan(designLibH, oocRead);

    while (atomicPartI.next()) {
        if (debugMode) {
            printf("    In Query7, partId = %d:\n", atomicPartI->id);
        }
	atomicPartI->DoNothing();
        count++;
    }
    return count;
}

